`G_E.Simulation` <-
function(GD,ha2,rg,re,NE,NQTN=NULL,NETN=NULL,effectunit=1){
    

    #############################
    #GD
    
    #############################
    if(is.null(NQTN))
    {print("Must give NQTN")}
    if(length(ha2)!=NE) 
    {
        #print("simulation paremeter error in h2")
        stop ("simulation paremeter error in h2")
    }

    Y=matrix(0,nrow(GD),NE)
    X=GD[,-1]
    taxa=as.character(GD[,1])


    m=ncol(X)
    n=nrow(X)
    #duplicate taxa
    cov_g=rg
    mu_g=array(0,NE)
    if(!is.matrix(rg)) as.matrix(rg)
    matrix_cov_g=rg





    ####### simulate QTN effect and variance in each environment
    gv<-mvrnorm(NQTN,t(mu_g),matrix_cov_g)
    QTN.position=sample(1:m,NQTN,replace=F)
    SNPQ=as.matrix(X[,(QTN.position)])
    bv=SNPQ%*%gv


    bv_var=diag(var(bv))
    
    ####### calculate P A I E variance
    taxa_name=NULL
    cov_e=diag(1,NE)
    for(i in 1:NE)
    {   
        taxa_name=append(taxa_name,paste("trait_",i,sep=""))
        ve_i=bv_var[i]*(1/ha2[i]-1)
        for(j in 1:NE)
        {
            ve_j=bv_var[j]*(1/ha2[j]-1)
            cov_e[i,j]=cov_e[j,i]=sqrt(ve_i*ve_j)


        }
    }


    residual=mvrnorm(n,t(mu_g),cov_e)
    Y=round((bv+residual),6)
    myY=cbind(as.data.frame(taxa),Y)
    colnames(myY)=c("taxa",taxa_name)
    
    
    
    
    return(list(Y=myY,u=bv,QTN.position=QTN.position,residual=residual))
} #enf of phenotype simulation function
#=============================================================================================


