######################################## creat Manhattan plot

rm(list=ls())
library('MASS') # required for ginv
library(multtest)
library(gplots)
library(compiler) #required for cmpfun
library("scatterplot3d")
library("EMMREML")
library(ape)
source("http://www.zzlab.net/GAPIT/emma.txt")
source("http://www.zzlab.net/GAPIT/gapit_functions.txt")
    
set.seed(99163)

system(paste("./GbyE --gwas --file ","gemtData --numeric ","--interaction ",n_e,sep=""))
result=read.table(paste("GbyE","_GWAS_result.txt",sep=""),head=T)
result=result[,c(1,2,3,5,4)]
chrom=result[1:(nrow(result)/n_e),2]
for(i in 1:n_e)
{
	result[(1+(i-1)*(nrow(result)/n_e)):((nrow(result)/n_e+(i-1)*(nrow(result)/n_e))),2]=chrom
}


source("http://www.zzlab.net/GbyE/Manhattan_g&e.R")
#result=cbind(newmap,result[,4])
GAPIT.Manhattan(GI.MP=result[,-1],name.of.trait="GW",Name_environ=c("13_FC_Irr","13_FC_Dry","12_Gr_Irr","12_Gr_Dry"),Nenviron=4)



######################################## complare power with blink_mean MLM_mean

rm(list=ls())
library('MASS') # required for ginv
library(multtest)
library(gplots)
library(compiler) #required for cmpfun
library("scatterplot3d")
library("EMMREML")
library(ape)
source("http://www.zzlab.net/GAPIT/emma.txt")
source("http://www.zzlab.net/GAPIT/gapit_functions.txt")
    ha2=c(0.8,0.8)
    
    NQTN=20
    NE=2
    rep=50
    cov_g=0.1
    cov_e=0.1
    rg=matrix(cov_g,NE,NE)
    diag(rg)=1
    re=matrix(cov_e,NE,NE)
    diag(re)=1
n_e=NE
set.seed(99163)
###########################################
setwd("/Users/Jiabo/Documents/GEMT/demo_data/data")

source("http://www.zzlab.net/GbyE/G_E.Duplicated.R")
source("http://www.zzlab.net/GbyE/G&E_Simulation.R")
GD=read.table("gemtData.dat",head=F)
GM=read.table("gemtData.map",head=T)
system("cp gemtData.cov blinkData.cov")

taxa=NULL
E_name=NULL
store_map=GM
for(i in 1:ncol(GD))
{
taxa[i]=paste("taxa_",i,sep="")
} 

diag_matrix=diag(1,n_e)
dupli_taxa=NULL
mapmap=NULL
X=as.matrix(GD)
dupliGD=kronecker(diag_matrix,X)

for(i in 1:NE)
{
    dupli_taxa=append(dupli_taxa,taxa)
    store_map[,2]=store_map[,2]+max(store_map[,2])*(i-1)
    mapmap=rbind(mapmap,store_map)
}

mean_fdr=NULL
gemt_fdr=NULL

for(k in 1:rep)
{

mysimu=G_E.Simulation(GD=cbind(as.data.frame(taxa),t(GD)),ha2=ha2,NQTN=NQTN,NE=NE,rg=rg,re=re)
myY=mysimu$Y
cor(myY[,2],myY[,3])

allposition=mysimu$QTN.position
Y=apply(as.matrix(myY[,-1]),1,mean)
newY=cbind(Y,as.matrix(myY[,-1]))
newY=cbind(as.data.frame(taxa),newY)
Y=cbind(as.data.frame(taxa),Y)
colnames(Y)=c("taxa","blink")
bootY=myY

dupli_Y=NULL
for(i in 1:NE)
{
    dupli_Y=append(dupli_Y,myY[,i+1])    
}

#for GEMT
write.table(myY,"mygemtData.txt",row.names=F,quote=F)

write.table(Y,"blinkData.txt",row.names=F,quote=F)

if(k==1)system("cp mygemtData.dat blinkData.dat")
if(k==1)system("cp mygemtData.map blinkData.map")

system(paste("./GbyE --gwas --file ","mygemtData --numeric ","--interaction ",n_e,sep=""))
system(paste("./biogpu0.9 --gwas --file ","blinkData --numeric ",sep=""))

N=nrow(GM)

gemt_result=read.table("GbyE_GWAS_result.txt",head=T)
P_V=matrix(gemt_result[,5],N,n_e)
min_P=apply(P_V,1,min)
min_result=gemt_result[1:N,]
min_result[,4]=min_P
gemt_result=gemt_result[,c(1,2,3,5,4)]

fdr_gemt=GAPIT.FDR.TypeI(GWAS=min_result,GM=GM,WS=1,maxOut=N,seqQTN=allposition)
gemt_fdr=cbind(gemt_fdr,fdr_gemt$FDR)

blink_result=read.table("blink_GWAS_result.txt",head=T)
blink_result=blink_result[,c(1,2,3,5,4)]
fdr_mean=GAPIT.FDR.TypeI(GWAS=blink_result,GM=GM,WS=1,maxOut=N,seqQTN=allposition)
mean_fdr=cbind(mean_fdr,fdr_mean$FDR)

}
gemt_plot=apply(gemt_fdr,1,mean)
mean_plot=apply(mean_fdr,1,mean)

add_power=seq(1/(NQTN),1,1/(NQTN))

tiff(file=paste("Blink_mean vs GbyE",ha2[1],"_rg_",cov_g,"_QTN_",NQTN,"_en_",NE,".tif",sep=""),width=150, height=150, units='mm',res=200,compression='lzw')

par(mar=c(4,4,2.5,2.5))
plot(as.numeric(mean_plot),add_power,col="darkred",xlim=c(0,1),ylim=c(0,1),yaxp=c(0,1,10),xaxp=c(0,1,10),type="b",ylab="",xlab="",lwd=1.3)
par(new=T)
plot(as.numeric(gemt_plot),add_power,col="black",xlim=c(0,1),ylim=c(0,1),xlab="",ylab="",axes=F,type="b",lwd=1.3)

mtext("FDR",side=1,line=2.5,col="black")
mtext("POWER",side=2,line=2.5,col="black")
legend("topleft",legend=c("Mean_Blink","GbyE"),ncol=1,
col=c("darkred","black"),pch=c(15,15),lty=0,lwd=1.3,cex=1,
bty = "n", bg = par("bg"))

dev.off()



